/*###############################################################################
# Copyright (C) MOXA Inc. All rights reserved.
#
# This software is distributed under the terms of the
# MOXA License.  See the file COPYING-MOXA for details.
#
# Purpose : MOXA LED library
# Return : 0 on success; Other wise, modification failed.
# Author : Lock Lin
# Date : 2014-03-17
# Version : 1.0
# Notes :
##############################################################################*/

#include <stdint.h>
#include <linux/input.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <signal.h>
#define MAXLINE 128

#define GREEN	"/sys/class/leds/UC8580:GREEN:SWRDY"

/* ignore */
#define YELLOW	"/sys/class/leds/UC8410A:YELLOW:DIA"
#define RED	"/sys/class/leds/UC8410A:RED:DIA"
/* ignore */

#define DEVICE_NODE	"/dev/input/event0"

int mx_btn_event_detect (int fd, int sec)
{
	struct timeval timeout;
	fd_set read_fds;

	FD_ZERO(&read_fds);
	FD_SET(fd, &read_fds);

	timeout.tv_sec = sec;
	timeout.tv_usec = 0;

	return select(fd + 1, &read_fds, NULL, NULL, &timeout);
}

int onoff_led (char *string, int status) 
{
	FILE *fp;
	int rt_val;
	char cmd[MAXLINE];
	memset(cmd, '\0', MAXLINE);
	if (strcmp(string, "GREEN") == 0) {
		snprintf(cmd, sizeof(cmd), "echo %d > %s/brightness", status, GREEN);
	//} else if (strcmp(string, "YELLOW") == 0) {
	//	snprintf(cmd, sizeof(cmd), "echo %d > %s/brightness", status, YELLOW);
	//} else if (strcmp(string, "RED") == 0) {
	//	snprintf(cmd, sizeof(cmd), "echo %d > %s/brightness", status, RED);
	} 
	fp = popen(cmd, "r");
	if(NULL == fp) {
		perror("Cannot execute cmd \n");
		return -1;
	}
	rt_val = pclose(fp);
	return rt_val;
}
int off_all_led () 
{
	if (onoff_led ("GREEN", 0))
		return -1;
	//if (onoff_led ("YELLOW", 0))
	//	return -1;
	//if (onoff_led ("RED", 0))
	//	return -1;
	return 0;
}

int on_all_led () 
{
	if (onoff_led ("GREEN", 1))
		return -1;
	//if (onoff_led ("YELLOW", 1))
	//	return -1;
	//if (onoff_led ("RED", 1))
	//	return -1;
	return 0;
}

int blink_all_led ()
{
	if (blink_led ("GREEN"))
		return -1;
	//if (blink_led ("YELLOW"))
	//	return -1;
	//if (blink_led ("RED"))
	//	return -1;
	return 0;
}

int blink_led (char *string) 
{
	FILE *fp;
	int rt_val;
	char cmd[MAXLINE];
	memset(cmd, '\0', MAXLINE);
	if (strcmp(string, "GREEN") == 0) {
		snprintf(cmd, sizeof(cmd), "echo heartbeat > %s/trigger", GREEN);
	//} else if (strcmp(string, "YELLOW") == 0) {
	//	snprintf(cmd, sizeof(cmd), "echo heartbeat > %s/trigger", YELLOW);
	//} else if (strcmp(string, "RED") == 0) {
	//	snprintf(cmd, sizeof(cmd), "echo heartbeat > %s/trigger", RED);
	}
	fp = popen(cmd, "r");
	if(NULL == fp) {
		perror("Cannot execute cmd \n");
		return -1;
	}
	rt_val = pclose(fp);
	return rt_val;
}

void exec_cmd (char *bin_name)
{
	system(bin_name);
#if 0
	char **cmd[32];
	FILE *fp;
	char rt_val[32];
	char cmd[MAXLINE];
	memset(cmd, '\0', MAXLINE);
	memset(rt_val, '\0', sizeof(rt_val));
	snprintf(cmd, sizeof(cmd), "%s", bin_name);
	fp = popen(cmd, "r");
	printf("cmd=%s\n", cmd);
	if(NULL == fp) {
		perror("Cannot execute cmd \n");
		exit(1);
	}
	fgets(rt_val, 32, fp);
	pclose(fp);
	printf("Exit\n");
#endif
}

int mx_open_device ()
{
	return open(DEVICE_NODE, O_RDONLY); 
}

int mx_close_device(int fd)
{
	close (fd);
}
